package acme

import (
	"fmt"
	"testing"
)

func TestRegister(t *testing.T) {
	register := Register("1302344380@qq.com")
	fmt.Println(register.Email)
	fmt.Println(register.PrivateKey)
	fmt.Println(register.Registration)
}

func TestParseRegister(t *testing.T) {
	res := RegisterRes{
		Email:        "1302344380@qq.com",
		Registration: "{\"body\":{\"status\":\"valid\",\"contact\":[\"mailto:1302344380@qq.com\"]},\"uri\":\"https://acme-v02.api.letsencrypt.org/acme/acct/2379447617\"}",
		PrivateKey:   "MIGHAgEAMBMGByqGSM49AgEGCCqGSM49AwEHBG0wawIBAQQgnxjIGpla+EGdl2+JcPBuE5T06wKYbp4x49aykmS84ryhRANCAARqMaBmXLfqgsJDmISHX9cLJcX19W51UjcKQ0rLllyf8YjOsxCZ+XHW/DpS/hh2VLgc5zpZtgBWOAskN1viAFKi",
	}

	user := User{}
	register := user.FromRegister(&res)
	fmt.Println(register.GetEmail())
	fmt.Println(register.GetPrivateKey())
	fmt.Println(register.GetRegistration())
}
